/*
 * Copyright (c) 1989-1996, 1999 by Sun Microsystems, Inc.
 * All rights reserved.
 */

#ifndef	_SYS_MD_MEM_H
#define	_SYS_MD_MEM_H

#pragma ident	"@(#)md_mem.h	2.2	01/05/08 SMI"

#include <sys/types.h>
#include <sys/kmem.h>

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef _KERNEL

#define	MD_FST_MAGIC		0x0BADCAFE
#define	MD_FST_RESERVE_MAGIC	0x0CAFEBAD

typedef struct md_fst_hdr {
	uint_t			 fh_inuse;
	struct md_fst_info	*fh_info;
	int			fh_reserve; /* only used with reserve */
} md_fst_hdr_t;

typedef struct md_fst_lnk {
	struct md_fst_hdr	*fl_hdr;
	uint_t			 fl_magic;
} md_fst_lnk_t;


typedef struct md_fst_info {
	size_t		fi_chunks;
	size_t		fi_low_mark;
	size_t		fi_high_mark;
	void		*(*fi_init)();
	void		(*fi_makefreemem)();
	void		*fi_freelist;
	size_t		fi_nfree;
	size_t		fi_alloc_size;
	size_t		fi_hdr_size;
	size_t		fi_lnk_size;
	size_t		fi_data_size;
	int		fi_wakeup_flg;
	int		fi_freeing;
	size_t		fi_reserve_offset;
	int		fi_refcnt;
	kmutex_t	fi_mx;
	kcondvar_t	fi_cv;
	size_t		fi_reserve_size;
	md_fst_lnk_t	**fi_reserve_array;
} md_fst_info_t;

/* Externals from md_mem.c */
extern void	*mdf_alloc(md_fst_info_t *fi, void *reservebase);
extern void	mdf_free(void *p);
extern void	*mdf_free_pool(md_fst_info_t *fi, void *reservebase);
extern void	*mdf_init_pool(void *mip, void *(*init)(),
		    void (*make_free_mem)(),
		    size_t size, size_t chunks, size_t high_mark,
		    size_t low_mark, void *base, void *reserve);
#endif	/* _KERNEL */

#ifdef	__cplusplus
}
#endif

#endif	/* _SYS_MD_MEM_H */
